using UnityEngine;
using System.Collections;

public class ConfirmarEscrita : MonoBehaviour {
	private Vector3 originalScale;
	//public static int pontos=0;

	//Guarda instancia unica do tabletEscrever
	TabletEscrita tabletEscrever;
	Transacoes transacoes;
	Animator animator;

	void Start () {
		originalScale = transform.localScale;
		tabletEscrever = TabletEscrita.Instance;
		transacoes = Transacoes.Instance;
		animator = GetComponent<Animator> ();
	}

	private void OnEnable()
	{
		Transacoes.Instance.GameOver += OnGameOver;
	}
	void OnGameOver()
	{
		Destroy(this);
	}

	void OnMouseExit()
	{
		renderer.transform.localScale = originalScale;
	}
	void OnMouseEnter()

	{
		renderer.transform.localScale *= 1.5f;
	}
	void OnMouseDown()
	{
		//animator.SetTrigger ("MouseDown");
		Queue resposta = tabletEscrever.listaDeResposta;
		bool certo = transacoes.ConfirmaEscrita (resposta);
		animator.SetTrigger (certo?"Certo":"Errado");
	}
}