using UnityEngine;
using System.Collections;

public class LimparTablet : MonoBehaviour {
	private Vector3 originalScale;
	TabletEscrita tabletEscrever;
	Animator animator;
	
	void Start () {
		originalScale = transform.localScale;
		tabletEscrever = TabletEscrita.Instance;
		animator = GetComponent<Animator> ();
	}

	private void OnEnable()
	{
		Transacoes.Instance.GameOver += OnGameOver;
	}
	void OnGameOver()
	{
		Destroy(this);
	}

	void OnMouseExit()
	{
        renderer.transform.localScale = originalScale;
    }
	void OnMouseEnter()
    {
        renderer.transform.localScale *=1.5f;
    }
	void OnMouseDown()
	{
		animator.SetTrigger ("MouseDown");
		//Destroi os objetos do tablet
		tabletEscrever.Destruir();
	}
}
