using UnityEngine;
using System.Collections;

public class Simbolo : MonoBehaviour {
	
    private Vector3 originalScale;
	private Vector3 originalPosition;
    private bool dragging = false;
    private float distance;
 	public Simbolos tipo;
	//public Color cor;
	public bool original = true;
	private bool onTablet = false;

	private float fatorSobreposicao = 0.1f;

	private void OnEnable()
	{
		Transacoes.Instance.GameOver += OnGameOver;
	}
	void OnGameOver()
	{
		Destroy(this);
	}
		
	void OnMouseEnter()
    {
        renderer.transform.localScale *=1.5f;
		transform.position = transform.position + (Vector3.back * fatorSobreposicao); //Corrige sobreposicao errada de simbolos
    }

    void OnMouseExit()
    {
        renderer.transform.localScale = originalScale;
		if(transform.position.z != originalPosition.z)
			transform.position = transform.position + (Vector3.forward * fatorSobreposicao); //Corrige sobreposicao errada de simbolos
    }
 
    void OnMouseDown()
	{
    	distance = Vector3.Distance(transform.position, Camera.main.transform.position);

    	dragging = true;
    }
	
    void OnMouseUp()
    {
		if(original){
        /*if(transform.localPosition.x > -31.0f && transform.localPosition.x < 4.0f &&
			transform.localPosition.y > -76.0f && transform.localPosition.y < -32.0f){*/
			//Se simbolo estiver em cima do tablet
			if(onTablet){
				transform.localScale = originalScale;
				TabletEscrita.Instance.Escrita(tipo, gameObject);
		} 
		
		transform.localPosition = originalPosition;
        dragging = false;
		}
    }
	
	void Start () {
		originalScale = transform.localScale;
		originalPosition = transform.localPosition;

	}

	public string GetSimbolo(){
		return tipo.ToString ();
	}

	void Update () {
		if (dragging && original)
        {
            Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
            Vector3 rayPoint = ray.GetPoint(distance);
            transform.position = new Vector3(rayPoint.x, rayPoint.y, transform.position.z);
        }
	}
	
	void OnTriggerEnter2D(Collider2D other){
		if (other.gameObject.name == "tablete-registro") 
		{
			onTablet = true;
		}
	}
	void OnTriggerExit2D(Collider2D other){
		if (other.gameObject.name == "tablete-registro") 
		{
			onTablet = false;
		}
	}


}
