using UnityEngine;
using System.Collections;


public class TabletEscrita : MonoBehaviour {
	
	private Vector3 originalPosition;
	private Vector3 Posicao1;
	private Vector3 Posicao2;
	private Vector3 Posicao3;
	static int posicaoAtual = 0;
	//public GameObject simbolo;

	//Lista de simbolos escolhidos
	public Queue listaDeSimbolos;
	//Lista das Strings do simbolos escolhidos
	public Queue listaDeResposta;
	
	//Garante que tabletEscrever tenha uma unica instancia
	//Implementacao de singleton
	private static TabletEscrita instance;
	public static TabletEscrita Instance
	{
		get
		{
			if(instance == null)
				instance = GameObject.FindObjectOfType(typeof(TabletEscrita)) as TabletEscrita;	
			return instance;
		}
	}

	
	void Start () {
		originalPosition = transform.localPosition;
		Posicao1.Set(transform.localPosition.x +20,transform.localPosition.y	,transform.localPosition.z);
		Posicao2.Set(transform.localPosition.x , transform.localPosition.y - 20f,transform.localPosition.z);
		Posicao3.Set(transform.localPosition.x + 20f, transform.localPosition.y - 20f,transform.localPosition.z);

		//Inicia listas
		listaDeSimbolos = new Queue();
		listaDeResposta = new Queue();
	}

	public void Escrita(Simbolos tipo, GameObject simbolo){
		if (simbolo) {
			//Define Z fixo para evitar erros de sobreposicao
			Vector3 position = new Vector3(this.transform.position.x, this.transform.position.y, -0.4f);
			GameObject novoSimbolo = Instantiate (simbolo, position, this.transform.rotation) as GameObject;

			listaDeSimbolos.Enqueue(novoSimbolo);
	
			Simbolo simbol = novoSimbolo.GetComponent<Simbolo> () as Simbolo;
			simbol.tipo = tipo;

			simbol.original = false;
			listaDeResposta.Enqueue(simbol.GetSimbolo());
		}

		posicaoAtual++;
		switch (posicaoAtual) {
		case 1:
			transform.localPosition = Posicao1;
			break;
		case 2:
			transform.localPosition = Posicao2;
			break;
		case 3:
			transform.localPosition = Posicao3;
			break;
		default:
			Debug.LogError("erro posicao errada");
			break;
		}
		Transacoes.Instance.ProximoSimbolo();
	}
	public void Destruir(){

		//Destroi todos os simbolos atuais e limpa as listas
		foreach(GameObject e in listaDeSimbolos)
		{
			Destroy(e);
		}
		listaDeSimbolos.Clear();
		listaDeResposta.Clear();

		//Resetando posicao inicial
		transform.localPosition = originalPosition;
		posicaoAtual = 0;
	}
}
