﻿using UnityEngine;
using System.Collections;

public abstract class DialogoMissao : MonoBehaviour {
	public GameObject caixaDialogo;
	public GUIStyle fonte;
	public GUIStyle fonte2;
	public int tamanho;
	protected int indice = 0;
	public int numeroMissao;
	public  string[,] falaNPC ;
	public  string[,] falaJogador;
	bool mostrarDialogo = false;
	public static int[] statusMissao = new int[7];
	int i = 0;
	bool mostraBotao;
	float x;
	float y;
	float w;
	float h;
	public abstract void ODialogoAcabou ();
	public abstract void SetCaixaDialogo (bool set);
	protected Vector4 dialogParam;	
	string repetirTxt;

	protected void init () {
		switch(LanguageManager.lang)
		{
			case 0:
				repetirTxt = "Pode repetir por favor?";
				break;
			case 1:
				repetirTxt = "Could you repeat, please?";
                break;
        }

		mostraBotao = true;
		x = 0.8f*(Screen.width/5);
		y = 0.5f*(Screen.height/5);
		w = .6f*Screen.width;
		h = .2f*Screen.height;
		fonte = new GUIStyle();
		fonte2 = new GUIStyle();
		fonte.normal.textColor = Color.black;
		fonte.fontSize = 13;
		fonte2.normal.textColor = Color.blue;
		fonte2.fontSize = 13;
		caixaDialogo = GameObject.Find ("CaixaDialogo");
		dialogParam = new Vector4 ();
		//print (Screen.width.ToString() + " " + Screen.height.ToString());
	}
	
	void Update() {

	}
	public void CaixaUpdateSize()
	{
		//center
		Vector2 point1 = new Vector2 (Screen.width - dialogParam.x , Screen.height- dialogParam.y);
		//top-left
		Vector2 point2 = new Vector2 (dialogParam.x, dialogParam.y);
		//bottom-left
		Vector2 point3 = new Vector2 (dialogParam.x, dialogParam.y + dialogParam.w);
		//Top-right
		Vector2 point4 = new Vector2 (dialogParam.x + dialogParam.z, dialogParam.y);
        Ray ray1 = Camera.main.ScreenPointToRay(point1);
		Ray ray2 = Camera.main.ScreenPointToRay(point2);
		Ray ray3 = Camera.main.ScreenPointToRay(point3);
		Ray ray4 = Camera.main.ScreenPointToRay(point4);
        RaycastHit info1;
		RaycastHit info2;
		RaycastHit info3;
		RaycastHit info4;
        //print (Physics.Raycast(ray1, out info1) + " "+ Physics.Raycast(ray2, out info2) + " "+ Physics.Raycast(ray3, out info3));

		if (Physics.Raycast(ray1, out info1) && Physics.Raycast(ray2, out info2) 
		    && Physics.Raycast(ray3, out info3)&& Physics.Raycast(ray4, out info4))
		{
			//print("reposicionando");
			Debug.DrawRay(info1.point, info1.normal, Color.blue, 10000f);
			//caixaDialogo.transform.position = info1.point;
			//print(info1.collider.name);

			if(info1.collider.name.Equals("CaixaDialogo"))
			{
				Vector3 globalCenter = info1.point;
				float globalWidth = Vector3.Distance(info4.point , info2.point);
				float globalHeight = Vector3.Distance(info3.point , info2.point);
				caixaDialogo.transform.position = new Vector3(
					globalCenter.x - 0.5f + globalWidth/2 ,
					3.742399f,  
					globalCenter.z + 0.5f - globalHeight/2);
				caixaDialogo.renderer.bounds.SetMinMax(info3.point, new Vector3(
					globalCenter.x + globalWidth ,
					3.742399f,  
					globalCenter.z));
                                                      

			}
		}
	}

	GUIStyle fontePraUsar;
	void OnGUI(){

		if (mostrarDialogo) {
			GUILayout.BeginArea (new Rect (3.2f*x,y,w,1.3f*h));
			dialogParam = new Vector4(3.2f*x,y,w,1.3f*h);
			if (Application.loadedLevelName.Equals("Aritmetica") || Application.loadedLevelName.Equals("CasaDoProfessor")) 
				fontePraUsar = fonte2;
			else
				fontePraUsar = fonte;
			GUILayout.Label(falaNPC[statusMissao[numeroMissao],indice],fontePraUsar);
			GUILayout.EndArea ();
			//CaixaUpdateSize();
			GUILayout.BeginArea (new Rect (3.2f*x,3.6f*y,w,2.0f*h));
			if(mostraBotao){
				print(tamanho + " - "+indice);
				if (GUILayout.Button (falaJogador[statusMissao[numeroMissao],indice], GUILayout.ExpandWidth (false))) {
					if (indice < tamanho - 1) {
						indice++;
					}
					if(indice == tamanho-2){
						mostraBotao=false;
						ODialogoAcabou();
					}
				}
			}
			if (indice > 0) {
				if (GUILayout.Button(repetirTxt, GUILayout.ExpandWidth (false))){
					indice = 0;
					mostraBotao = true;
				}
				
			}
			if (indice >= tamanho - 1) {

				mostrarDialogo = false;
				
			}
			GUILayout.EndArea ();
		}
		
	}
	
	
	void OnTriggerEnter(Collider other) 
	{
		//caixaDialogo.renderer.enabled = true;
		mostrarDialogo = true;
		indice = 0;
		mostraBotao = true;
		//SetCaixaDialogo (true);
	}
	
	void OnTriggerExit(Collider other) 
	{
		mostrarDialogo = false;
		indice = 0;
		//SetCaixaDialogo (false);
	}
}

