﻿using UnityEngine;
using UnityEditor;
using System.Collections;

public class AjustaPortas : ScriptableObject
{
	private enum COLLIDER_TYPE {Sphere, Box, Capsule};
	
	private static COLLIDER_TYPE colliderType;
	
	private	static string	myName; 
	
	// capsule
	private static Vector3 	capsuleCenter;
	private static float 	capsuleRadius;
	private	static float	capsuleHeight;
	private	static int		capsuleDirection;
	
	// sphere
	private	static Vector3	sphereCenter;
	private	static float	sphereRadius;
	
	// box
	private static Vector3	boxCenter;
	private	static Vector3	boxSize;

	[MenuItem ("Custom/posicionaTransform")]
	static void posiciona()
	{
		Selection.transforms [0].position = Selection.transforms [1].position;
	}
    
	[MenuItem ("Custom/AjustaPortasFlorenza")]
	static void Ajusta()
	{
		if (Selection.transforms.Length == 0) 
		{
			Debug.Log("trans nao selecionado");
			return;
		}
		Transform trans = Selection.activeGameObject.GetComponent<Transform> ();

		Transform tPrnt = trans.parent;
		if (trans) 
		{
			foreach(Porta2 p in GameObject.FindObjectsOfType(typeof(Porta2)) as Porta2 [])
			{

				if(!p.name.Equals(trans.name))
				{
					Debug.Log(p.name+ " " + p.lugar);
					GameObject cube = GameObject.CreatePrimitive(PrimitiveType.Cube);
					cube.transform.parent = p.transform.parent;
					trans.parent = cube.transform.parent;
					cube.transform.position = trans.position;
					cube.transform.localScale = trans.localScale;
					cube.transform.rotation = trans.rotation;
					cube.transform.position = new Vector3(p.transform.position.x, 
					                                      trans.position.y,
					                                      p.transform.position.z);
					cube.name = p.name;
					trans.parent = tPrnt;
					Porta2 nPorta = cube.AddComponent<Porta2>();
					nPorta.lugar = p.lugar;
					nPorta.ponto = p.ponto;
					cube.collider.isTrigger = true;
					cube.gameObject.tag = "Porta";
					DestroyImmediate(p.gameObject);
					//p.gameObject.SetActive (false);
					//break;
				}
			}
		}
    }

	[MenuItem ("Custom/GrowCollidersGrow")]
	static void Grow()
	{
		if (Selection.transforms.Length == 0)
		{
			Debug.Log("trans nao selecionado");
			return;
		}
		Transform trans = Selection.activeGameObject.GetComponent<Transform> ();
		
		//Transform tPrnt = trans.parent;
		if (trans) 
		{
			foreach(Transform t in GameObject.FindObjectsOfType(typeof(Transform)) as Transform[])
			{
				
				if(!t.name.Equals("Jogador") && !t.name.Equals("Chao")&& !t.name.Equals("Ponte"))
				{
					BoxCollider colider = t.GetComponent<BoxCollider>();
					if(colider)
					{
						Vector3 size = colider.size;
						colider.size = new Vector3(size.x, size.y *10, size.z);
					}
				}
			}
		}
	}
	
	[MenuItem ("Custom/Collider Copier/Copy Collider")]
	static void DoRecord()
	{
		if(Selection.activeTransform.GetComponent<SphereCollider>()!=null)
		{
			colliderType = COLLIDER_TYPE.Sphere;
			sphereCenter = Selection.activeTransform.GetComponent<SphereCollider>().center;
			sphereRadius = Selection.activeTransform.GetComponent<SphereCollider>().radius;
		}
		
		if(Selection.activeTransform.GetComponent<CapsuleCollider>()!=null)
		{
			colliderType = COLLIDER_TYPE.Capsule;
			capsuleCenter = Selection.activeTransform.GetComponent<CapsuleCollider>().center;
			capsuleRadius = Selection.activeTransform.GetComponent<CapsuleCollider>().radius;
			capsuleHeight = Selection.activeTransform.GetComponent<CapsuleCollider>().height;
			capsuleDirection = Selection.activeTransform.GetComponent<CapsuleCollider>().direction;
		}
		
		if(Selection.activeTransform.GetComponent<BoxCollider>()!=null)
		{
			colliderType = COLLIDER_TYPE.Box;
			boxCenter = Selection.activeTransform.GetComponent<BoxCollider>().center;
			boxSize = Selection.activeTransform.GetComponent<BoxCollider>().size;
		}
		
		myName = Selection.activeTransform.name;       
		
		EditorUtility.DisplayDialog("Collider Copy", "Local settings of " + myName + " collider copied", "OK", "");
	}
	
	[MenuItem ("Custom/Collider Copier/Paste Collider")]
	static void DoApply()
	{
		switch(colliderType)
		{
		case COLLIDER_TYPE.Sphere:
			if(Selection.activeTransform.GetComponent<SphereCollider>()==null)
			{
				EditorUtility.DisplayDialog("DANGER", "Can't paste onto that (not a sphere collider)", "Bah!");
				return;
			}
			Selection.activeTransform.GetComponent<SphereCollider>().center = sphereCenter;
			Selection.activeTransform.GetComponent<SphereCollider>().radius = sphereRadius;
			break;
		case COLLIDER_TYPE.Capsule:
			if(Selection.activeTransform.GetComponent<CapsuleCollider>()==null)
			{
				EditorUtility.DisplayDialog("DANGER", "Can't paste onto that (not a capsule collider)", "Bah!");
				return;
			}
			Selection.activeTransform.GetComponent<CapsuleCollider>().center = capsuleCenter;
			Selection.activeTransform.GetComponent<CapsuleCollider>().radius = capsuleRadius;
			Selection.activeTransform.GetComponent<CapsuleCollider>().height = capsuleHeight;
			Selection.activeTransform.GetComponent<CapsuleCollider>().direction = capsuleDirection;
			break;
		case COLLIDER_TYPE.Box:
			if(Selection.activeTransform.GetComponent<BoxCollider>()==null)
			{
				EditorUtility.DisplayDialog("DANGER", "Can't paste onto that (not a box collider)", "Bah!");
				return;
			}
			Selection.activeTransform.GetComponent<BoxCollider>().center = boxCenter;
			Selection.activeTransform.GetComponent<BoxCollider>().size = boxSize;
			break;
			
		}
		EditorUtility.DisplayDialog("Collider Copy", "Local settings of " + myName + " collider pasted", "OK", "");
	}
	
}